commit 546cf317558bfb178b7cadd346bb43cb963e9ce6
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Jun 14 13:30:52 2021

    libstdc++: Implement LWG 3465 for std::compare_partial_order_fallback [PR101056]
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/101056
            * libsupc++/compare (compare_partial_order_fallback): Add
            constraint using reversed parameter order, as per LWG 3465.
            * testsuite/18_support/comparisons/algorithms/fallback.cc:
            Adjust expected result.
    
    (cherry picked from commit b76a529c095f076c4780df0c913cf6d2391bcbc9)

diff --git a/libstdc++-v3/libsupc++/compare b/libstdc++-v3/libsupc++/compare
index b1f342113f1..dd0ec5fa36d 100644
--- a/libstdc++-v3/libsupc++/compare
+++ b/libstdc++-v3/libsupc++/compare
@@ -806,6 +806,16 @@ namespace std
 	}
     };
 
+    // _GLIBCXX_RESOLVE_LIB_DEFECTS
+    // 3465. compare_partial_order_fallback requires F < E
+    template<typename _Tp, typename _Up>
+      concept __op_eq_lt_lt = __op_eq_lt<_Tp, _Up>
+	&& requires(_Tp&& __t, _Up&& __u)
+	{
+	  { static_cast<_Up&&>(__u) < static_cast<_Tp&&>(__t) }
+	    -> convertible_to<bool>;
+	};
+
     class _Partial_fallback
     {
       template<typename _Tp, typename _Up>
@@ -821,7 +831,7 @@ namespace std
 
     public:
       template<typename _Tp, __decayed_same_as<_Tp> _Up>
-	requires __partially_ordered<_Tp, _Up> || __op_eq_lt<_Tp, _Up>
+	requires __partially_ordered<_Tp, _Up> || __op_eq_lt_lt<_Tp, _Up>
 	constexpr partial_ordering
 	operator()(_Tp&& __e, _Up&& __f) const
 	noexcept(_S_noexcept<_Tp, _Up>())
@@ -829,7 +839,7 @@ namespace std
 	  if constexpr (__partially_ordered<_Tp, _Up>)
 	    return _Partial_order{}(static_cast<_Tp&&>(__e),
 				    static_cast<_Up&&>(__f));
-	  else // __op_eq_lt<_Tp, _Up>
+	  else // __op_eq_lt_lt<_Tp, _Up>
 	    return static_cast<_Tp&&>(__e) == static_cast<_Up&&>(__f)
 	      ? partial_ordering::equivalent
 	      : static_cast<_Tp&&>(__e) < static_cast<_Up&&>(__f)
diff --git a/libstdc++-v3/testsuite/18_support/comparisons/algorithms/fallback.cc b/libstdc++-v3/testsuite/18_support/comparisons/algorithms/fallback.cc
index ae458528f17..05e1bf7775e 100644
--- a/libstdc++-v3/testsuite/18_support/comparisons/algorithms/fallback.cc
+++ b/libstdc++-v3/testsuite/18_support/comparisons/algorithms/fallback.cc
@@ -38,5 +38,5 @@ static_assert( has_weak_order_fallback<S, S> );
 static_assert( has_weak_order_fallback<const S, S> );
 static_assert( ! has_weak_order_fallback<const S, const S> );
 static_assert( has_partial_order_fallback<S, S> );
-static_assert( has_partial_order_fallback<const S, S> );
+static_assert( ! has_partial_order_fallback<const S, S> ); // LWG 3465
 static_assert( ! has_partial_order_fallback<const S, const S> );

